
function SetClassificationTokenListener(account,folder){
	this.account=account;
	this.folder=folder;
	this.onTokenAvailable=function(uri,tokenizer){
		this.account.onSetClassificationTokenAvailable(uri,this.folder,tokenizer);
	}
}

function Account(mozillaAcc,controller){

	this.setTokenizer=function(uri,tokenizer){
		var mail=this.mail[uri];
		if(mail) mail.tokenizer=tokenizer; 		
	}
	this.onTokenAvailable=function(uri,tokenizer){
		this.setTokenizer(uri,tokenizer);
		for(fol in this.uFolders){
			this.uFolders[fol].classifyMessage(uri,tokenizer);
		}
	}
	this.onSetClassificationTokenAvailable=function(uri,folder,tokenizer){
		this.setTokenizer(uri,tokenizer);
		this.setClassificationWithTokenizer(uri,folder,tokenizer);
	}
	this.setClassificationWithTokenizer=function(uri,folder,tokenizer){
		for(fol in this.uFolders){
			var foll=this.uFolders[fol];
			if(foll==folder){
				foll.setMessageClassification(uri,tokenizer,Components.interfaces.nsIMCFilter.GOOD);
			}
			else{
				foll.setMessageClassification(uri,tokenizer,Components.interfaces.nsIMCFilter.BAD);
			}
		}
	}
	this.onMessageClassified=function(msgUri,classification,folder){
		var msg=this.mail[msgUri];
		if(msg && classification>=this.minP){
			msg.setClassification(folder,classification);
			refreshClassifications();
		}
	}
	this.classifyMessage=function(msg){
		var msg1=this.mail[msg.msgURI];
		if(!msg1){
			this.mail[msg.msgURI]=msg;
			msg1=msg;
		}
		if(!msg1.isClassified()){
			this.controller.setAccountForURI(msg.msgURI,this);
			if(this.uFolders.length>0){
				var tok=msg1.tokenizer;
				if(!tok){
					tokenizeMessage(msg.msgURI,this);
				}
				else{
					this.onTokenAvailable(msg.msgURI,tok);
				}
			}
		}
		else{
			refreshClassifications();
		}
	}
	this.unclassifyMessage=function(msgURI){
		var mail=this.mail[msgURI];
		if(mail) mail.removeClassifications();
	}
	this.forceClassify=function(msg){
		this.unclassifyMessage(msg.msgURI);
		this.classifyMessage(msg);
	}
	this.getClassificationFor=function(msgURI){
		return this.mail[msgURI];
	}
	this.setClassificationFor=function(msgURI,folderURI){
		var folder=null;
		for(var i=0;i<this.uFolders.length;i++){
			var fol=this.uFolders[i];
			if(fol.getURI()==folderURI){
				folder=fol;
				break;
			}
		}
		if(folder){
			var msg=new Message(msgURI);
			msg.setClassification(folder,1);
			this.mail[msgURI]=msg;
			this.controller.setAccountForURI(msgURI,this);
		}
	}
	this.getFolderForMozillaFolder=function(mozFolder){
		var ret=null;
		for(var i=0;i<this.uFolders.length;i++){
			var fol=this.uFolders[i];
			if(fol.mozillaFolder==mozFolder){
				ret=fol;
				break;
			}
		}
		return ret;
	}
	this.removeUFolder=function(mozFolder){
		var a=new Array();
		for(x in this.uFolders){
			ufol=this.uFolders[x];
			if(ufol.mozillaFolder==mozFolder){
				//dump("delete : "+ufol.mozillaFolder.name+"\n");
				//delete this.uFolders[x];
			}
			else a.push(ufol);
		}
		this.uFolders=a;
		for(x in this.mail){
			msg=this.mail[x];
			msg.removeFolder(mozFolder);
		}		
	}
	this.removeFolderFromClassifications=function(mozFolder){
		var folder=this.getFolderForMozillaFolder(mozFolder);
		if(folder!=null){
			folder.removed(this);
			/*var added=null;
			var account=null;
			if(controller.addedFolders.length>0){
				added= controller.addedFolders.shift().mozillaFolder;
				account= controller.addedFolders.shift();
				dump(added.name);
			}
			if(added!=null && added.name==folder.mozillaFolder.name){
				account.changeFolderTo(added,folder);
			}
			else{*/

			//}
		}
	}
	this.changeFolderTo=function(mozFolder,uFolder){
		var parent=this.getFolderForMozillaFolder(mozFolder.parent);
		this.removeUFolder(mozFolder);
		uFolder.changeMozFolder(mozFolder,this,true,parent);
	}
	this.addFolderToClassifications=function(mozFolder){
		var parent=mozFolder.parent;
		parent=this.getFolderForMozillaFolder(parent);
		var ufolder=new UFolder(mozFolder,this,parent);
		//controller.addedFolders=new Array();
		//controller.addedFolders.push(ufolder);
		//controller.addedFolders.push(this);
		//dump(controller.addedFolders.length+"ciao");
	}
	this.setClassification=function(msgURI,folder){
		var msg=this.mail[msgURI];
		if(!msg) msg=new Message(msgURI);
		else msg.removeClassifications();
		this.mail[msgURI]=msg;
		var fol=this.getFolderForMozillaFolder(folder);
		if(fol){
			var tok=msg.tokenizer;
			if(tok){
				this.onSetClassificationTokenAvailable(msgURI,fol,tok);
			}
			else{
				var list=new SetClassificationTokenListener(this,fol);
				tokenizeMessage(msgURI,list);
			}	
		}	
	}
	this.observe=function(subject,topic,data){
		if(topic=="quit-application"){
			this.shutdown();
		}
	}
	this.shutdown=function(){
		this.cache.saveClassifications();
	}

	this.uFolders=new Array();
	this.mail=new Array();
	this.minP=0.6;
	this.mozAccount=mozillaAcc;
	this.controller=controller;
	this.cache=new ClassificationCache(this);
	observerService.addObserver(this,"quit-application",false);
	var rootFolder=mozillaAcc.rootFolder;
	var rootName=rootFolder.name;
	
	var folders = rootFolder.GetSubFolders();
	var done=false;
	while(!done){
		var folder = folders.currentItem().QueryInterface(Components.interfaces.nsIMsgFolder);
		if(isUserFolder(folder)){
			try{			
				var ufolder=new UFolder(folder,this);
			}
			catch(e){
				if(e == "cannot_create"){ 
					alert(extbundle.GetStringFromName("ufolder.cannot_create"));
					break;
				}
			}
		}
	    	try {
        		folders.next();
        	} 
        	catch (ex){
        		done = true;
        	}
	}
	this.cache.loadClassifications();
}
